package concurrent.safelock;

import java.util.ArrayList;

public class NumberPart implements Runnable {
	private String name;
	private ArrayList<Integer> numbers = new ArrayList<Integer>();
	private NumberTower tower;
	private int lockGainedCount = 0;
	public NumberPart(NumberTower tower, String name) {
		this.name = name;
		this.tower = tower;
	}
	
	public void allocate(Integer i){
		numbers.add(i);
	}
	
	public int size() {
		return numbers.size();
	}
	
	public void run() {
		while ( numbers.size() > 0 ){
			tower.pile(this);
		}
		System.out.println(this.name +"'s Lock Count : " + lockGainedCount);
	}
	public boolean hasValue (int val){
		if ( numbers.contains(new Integer(val)) ) return true;
		else return false;
	}
	public void remove(int val){
		if ( numbers.remove(new Integer(val)) ){
			System.out.println(val + " from " + this.name + ":" + this.toString());
			lockGainedCount++;
		}
	}
	public String toString(){
		StringBuffer buf = new StringBuffer();
		int length = numbers.size();
		for (int i = 0; i < length; i++) {
			buf.append(numbers.get(i) + ", ");
		}
		if ( buf.length() > 0 ) buf.delete(buf.length()-2, buf.length());
		return buf.toString();
	}
}