package concurrent.safelock;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class NumberTower {
	private int top;
	private int current = 0;
	private long startTime = 0;
	final private Lock lock = new ReentrantLock(); 
	
	Condition timeNotificationCondition = null;
	public NumberTower(int size){
		top = size; 
	}
	
	public int currentNumber(){
		return current;
	}
	
	public void check(){
		startTime = System.currentTimeMillis();
	}
	public void pile ( NumberPart np ){
		lock.lock();
		try {
			if ( np.hasValue(current )){
				np.remove(current);
				current++;
			}
			if ( current == top )
				timeNotificationCondition.signalAll();
		} finally {
			lock.unlock();
		}
	}
	public void getElapsedTime(){
		lock.lock();
		try {
			timeNotificationCondition = lock.newCondition();
			while ( current < top ) {
				System.out.println("wating..............");
				timeNotificationCondition.await();
			}
			System.out.println("elapsed " + (System.currentTimeMillis() - startTime));
		} catch (InterruptedException e) {
			Thread.currentThread().interrupt();
		} finally {
			lock.unlock();
		}
	}
}