package concurrent.safelock;

import java.util.Random;

public class ReentrantLockTest {
	final private static int NUM_SIZE = 300;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		NumberTower tower = new NumberTower(NUM_SIZE);
		NumberPart [] parts = new NumberPart[]{
				new NumberPart(tower, "Jane"),
				new NumberPart(tower, "Micheal"),
				new NumberPart(tower, "Sujan"),
				new NumberPart(tower, "Jack")
		};
		
		Integer [] numbers = new Integer[NUM_SIZE];
		for (int i = 0; i < numbers.length; i++)
			numbers[i] = new Integer(i);
		
		shuffle(numbers);
		
		Random r = new Random();
		for( int i = 0 ; i < NUM_SIZE ; i++ )
			parts[r.nextInt(parts.length)].allocate(numbers[i]);
//		printPart(parts);
		tower.check();
		for (int i = 0; i < parts.length; i++) {
			new Thread(parts[i]).start();
		}
		tower.getElapsedTime();
	}
	private static void shuffle(Integer [] numbers ){
		Random r = new Random();
		Integer tmp = null;
		for( int i = 0 ; i < 400 ; i++){
			int idx0 = r.nextInt(40);
			int idx1 = r.nextInt(40);
			tmp = numbers[idx0];
			numbers[idx0] = numbers[idx1];
			numbers[idx1] = tmp;
		}
	}
	private static void printInteger(Integer [] is){
		for (int i = 0; i < is.length; i++) {
			System.out.print(is[i] + ", ");
		}
		System.out.println();
	}
	private static void printPart(NumberPart [] np){
		for (int i = 0; i < np.length; i++) {
			System.out.println(np[i]);
		}
	}

}
